#include <locale.h>
#include <ncurses.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <string.h>

/* compile with this command: gcc -Wall machine.c -lncursesw -o machine */

/* This password machine is part of UNDEFINED festival. url: https://undefined.chaosconstructions.ru/ */

char *big_logo = "\n"
"      ---=== ^▄      ▄   ██▄   ▄███▄&-^▄████  ▄█&--^▄   ▄███▄   ██▄ &---===--\n"
"     ---===  ^ █      █  █  █  █▀   ▀  █▀   ▀ ██     █  █▀   ▀  █  █&--===---\n"
"    ---===   ^  █ ██   █ █   █ ██▄▄    █▀▀    ██ ██   █ ██▄▄    █   █&-==--- \n"
"   ---===  ^█   █ █ █  █ █  █  █▄   ▄▀ █      ▐█ █ █  █ █▄   ▄▀ █  █&-==---  \n"
"  ---===   ^█▄ ▄█ █  █ █ ███▀  ▀███▀    █      ▐ █  █ █ ▀███▀   ███▀&-=---   \n"
" ---===     ^▀▀▀  █   ██&   ---====---  ^▀       █   ██&         ---==---    \n"
"\n"
"         ----====^ВЫДАЧА КОНТРОЛЬНЫХ БРАСЛЕТОВ ДЛЯ ФЕСТИВАЛЯ&====----\n";  
 

int ch;
int exit_yes = 0;
int answer;
struct timespec t;

void machine_draw_color_text (char *readonly) {
	char buf [4096];
	if (!readonly) return;
	strncpy(buf, readonly, sizeof(buf));
	char *p = buf;
	while (*p) {
		char temp =p[1];
		p[1] = 0;
		if ('^' == *p) {attron(A_BOLD); attron(COLOR_PAIR(1)); *p = ' ';}
		if ('&' == *p) {attroff(A_BOLD); attroff(COLOR_PAIR(1)); *p = ' ';}
		printw("%s", p);
		p[1] = temp;
		if ('[' == *p) {attron(A_BOLD); attron(COLOR_PAIR(2));}
		p++;
		if (']' == *p) {attroff(COLOR_PAIR(2)); attroff(A_BOLD);}
		refresh();
		t.tv_sec = 0;
		t.tv_nsec = 2000000;
		nanosleep(&t, 0);
	}
}


int passmachine_input (int c, int pass, int no_question_sound,
			int do_not_wait, char *prompt1, char *prompt2) {
	int bfield = 0;
	char *text = "знаков";
	if (2 == c) text = "знака";
	
	refresh();
	t.tv_sec = 0;
	t.tv_nsec = 800000000;
	if (!do_not_wait) nanosleep(&t, 0);
	
	machine_draw_color_text(prompt1);
	/* play beep */
	int fork_id = fork();
	if (0 == fork_id) {
		if (!no_question_sound) execl("/bin/sh", "sh", "-c", "play -q question.wav", (char *) 0);
		exit(0);
	}
	printw("%s (%i %s): ", prompt2, c, text);
	/* TODO empty buffer here */
	
	int spacer = 0;
	while (1) {
		if (0 == (spacer & 0b11)) printw(" ");
		ch = getch();
		if (27 == ch) /* escape */ {
			exit_yes = 1;
			return 0;
		}
		if ('1' == ch) {
			printw(pass ? "*" : "1");
			bfield |= 1;
		} else {
			printw(pass ? "*" : "0");
		}
		refresh();
		
		waitpid(-1, 0, WNOHANG); /* wait for zombie processes */
		waitpid(-1, 0, WNOHANG);
		
		/* play beep */
        fork_id = fork();
        if (0 == fork_id) {
			if (!no_question_sound) execl("/bin/sh", "sh", "-c", "play -q keypress3.wav", (char *) 0);
			exit(0);
		}
		
		c--;
		if (!c) break;
		bfield <<= 1;
		spacer++;
	}
	t.tv_sec = 0;
	t.tv_nsec = 500000000;
	nanosleep(&t, 0);
	return bfield;
}


int check_bits (int p) {
  /* top secret */
  return 1;
}


void clear_and_wait (void) {
	clear();
	refresh();
	t.tv_sec = 0;
	t.tv_nsec = 500000000;
	nanosleep(&t, 0);
}


int main(int argc, char **argv) {
	setlocale(LC_ALL, "");
	initscr();
	noecho();
	start_color();
	init_pair(1, COLOR_WHITE, COLOR_BLACK);
	init_pair(2, COLOR_YELLOW, COLOR_BLACK);
	
main_screen:
	clear_and_wait();
	machine_draw_color_text(big_logo);
	machine_draw_color_text(
"\n      Вы на главном экране. Нажимайте кнопки [1] и [0], чтобы ввести\n"
"     команду. Нажмите [reset] в любой момент, чтобы вернуться к главному\n"
"    экрану, удерживайте три секунды, чтобы перезагрузить терминал целиком\n\n");
	
	answer = passmachine_input(2, 0, 0, 0, "[00] Показать скринсейвер\n"
	"[01] Пожертвования наличными (для Undefined)\n"
	"[10] У меня есть пароль\n"
	"[11] Решить задачу\n\n", "Выбор");
	if (exit_yes) goto loop_exit;
	refresh();
	goto main_screen;
	
loop_exit:
	
	endwin();
	return 0;
}

		//int inp = passmachine_input(16, 0);
		//if (exit_yes) break;
		//if (check_bits(inp)) {
			/* printw("  Верно\n"); */
			/* проверить повторное использование */
			/* выдать браслет */


		/* printw("The pressed key is ");
		attron(A_BOLD);
		attron(COLOR_PAIR(1));
		printw("%c (%i)\n", ch, ch);
		attroff(COLOR_PAIR(1));
		attroff(A_BOLD); */


/*  getmaxyx(stdscr,row,col);
 mvprintw(row/2,(col-strlen(mesg))/2,"%s",mesg);
 mvprintw(row-2,0,"This screen has %d rows and %d columns\n",row,col);
 printw("Try resizing your window(if possible) and then run this program again");
 refresh();
 */



